<template>
  <template-page ref="pageRef" :get-list="getList" :table-attributes="tableAttributes" :table-events="tableEvents"
    :operationColumnWidth="80" :options-evens-group="optionsEvensGroup" :moreParameters="moreParameters"
    :column-parsing="columnParsing" :operation="operation" :exportList="exportList">
    <el-dialog title="" width="500px" custom-class="diy-dialog" append-to-body :modal="true" :visible.sync="formDialog"
      :show-close="true" :close-on-click-modal="false" :modal-append-to-body="false" :before-close="formCancel">
      <zj-form-container ref="formRef" :form-data="formData" :styleSwitch="false">
        <zj-form-module :title="formDialogTitles[formDialogType]" label-width="80px" :showPackUp="false"
          :form-data="formData" :form-items="formItems" :disabled="formDialogType == 2">
        </zj-form-module>
      </zj-form-container>
      <div slot="footer" class="dialog-footer">
        <el-button size="mini" @click="formCancel">取 消</el-button>
        <el-button size="mini" type="primary" @click="formConfirm()">确定</el-button>
      </div>
    </el-dialog>
  </template-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import ImageUpload from '@/components/file-upload'
import { required, mobileRequired, mobile, httpUrl, email } from '@/components/template/rules_verify.js'
import { listPageV2, pageExport, getDetail, add, edit, del } from "@/api/thirdPartyAddressLogin";
import operation_mixin from '@/components/template/operation_mixin.js'
export default {
  components: { TemplatePage, ImageUpload },
  mixins: [import_mixin, operation_mixin],
  data() {
    return {
		// 事件组合
		optionsEvensGroup: [
			[
				[
					{
						name: '新增',
						isRole: JSON.parse(localStorage.getItem('greemall_user')).userName == 'admin',
						click: this.addData
					}
				],
			],
		],
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: false
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      // 勾选选中行
      recordSelected: [],
      /** 表单变量 */
      formDialogType: 0,
      formDialogTitles: ["新增", "编辑", "详情"],
      formDialog: false,
      formData: {
		urlName: '',
		url: '',
		remark: '',
		status: 'ON',
      }
    }
  },
  computed: {
    // 更多参数
    moreParameters() {
      return []
    },
    formItems() {
      return [{
        md: 24,
        isShow: true,
        name: 'el-input',
        attributes: { placeholder: '请输入网址名称', },
        formItemAttributes: {
          label: '网址名称',
          prop: 'urlName',
          rules: [...required]
        }
      }, {
        md: 24,
        isShow: true,
        name: 'el-input',
        attributes: { placeholder: '请输入网址链接', },
        formItemAttributes: {
          label: '网址链接',
          prop: 'url',
          rules: [...required]
        }
      }, {
	  	md: 24,
	  	isShow: true,
	  	name: 'el-input',
	  	attributes: { placeholder: '请输入说明内容', type: "textarea", rows: 5 },
	  	formItemAttributes: {
	  		label: '说明',
	  		prop: 'remark',
	  		rules: [...required]
	  	}
	  },{
        md: 24,
        isShow: true,
        name: 'slot-component',
        attributes: {},
        formItemAttributes: {
          label: '状态',
          prop: 'status',
          rules: [...required]
        },
		render: (h, { props, onInput }) => {
			var { value } = props
			return (
				<el-radio-group v-model={this.formData.status}>
						<el-radio label="ON">启用</el-radio>
						<el-radio label="OFF">禁用</el-radio>
				</el-radio-group>
			)
		}
    }]
    }
  },
  methods: {
    // 列表请求函数
		getList(p, cb) {
			try {
				var pam = JSON.parse(JSON.stringify(p))
				if(JSON.parse(localStorage.getItem('greemall_user')).userName != 'admin'){
					pam.params.push({ 'param': 'a.status', "compare": "=", "value": 'ON' })
				}
				cb && cb(pam)
				return listPageV2(pam)
			} catch (error) {
				console.log(error)
			}
		},
    // 列表导出函数
    exportList: pageExport,
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
		if(JSON.parse(localStorage.getItem('greemall_user')).userName != 'admin'){
			if (item.jname === 'url' || item.jname === 'status' || item.jname === 'createBy' || item.jname === 'createTime' || item.jname === 'updateBy' || item.jname === 'updateTime') {
				defaultData.hidden = true
			}
			if (item.jname === 'urlName') {
				console.log(defaultData)
				defaultData.render = (h, { row, index, column }) => {
					return (<el-link style="padding: 6px;" href={row.url} underline={false} target="_blank">{row.urlName}</el-link>)
				}
			}
		}
		
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },

    // 表格操作列
    operation(h, { row, index, column }) {
    	return (<div class='operation-btns'>
    		{JSON.parse(localStorage.getItem('greemall_user')).userName == 'admin' ? <el-button type="text" onClick={() => {
    			getDetail({
    				id: row.id
    			}).then(res => {
    				Object.assign(this.formData, res.data)
    				this.formDialogType = 1
    				this.openForm()
    			})
    		}}>编辑</el-button> : null}
    		{JSON.parse(localStorage.getItem('greemall_user')).userName == 'admin' ? <el-popconfirm
    			title={`是否确定删除？`}
    			onConfirm={() => {
    				noticeDel({
    					id: row.id
    				}).then(res => {
    					this.$message({
    						type: 'success',
    						message: '删除成功!'
    					})
    					this.$refs.pageRef.refreshList()
    				})
    			}}
    		>
    			<el-button type="text" slot="reference">删除</el-button>
    		</el-popconfirm> : null}
			{JSON.parse(localStorage.getItem('greemall_user')).userName != 'admin' ? <el-button type="text" onClick={() => {
    			window.open(row.url)
    		}}>登陆</el-button> : null}
    	</div>)
    },

    addData() {
      this.formDialogType = 0
      this.openForm()
    },
    openForm() {
      this.formDialog = true;
    },
    formCancel() {
      this.$refs.formRef.$refs.inlineForm.clearValidate()
      this.$data.formData = this.$options.data().formData
      this.formDialog = false
    },
    formConfirm() {
      this.$refs.formRef.validate((valid, invalidFields, errLabels) => {
        if (valid) {
          ([add, edit][this.formDialogType])(this.formData).then(res => {
            this.$message({ type: 'success', message: `${this.formDialogTitles[this.formDialogType]}成功!` })
            this.formCancel()
            this.$refs.pageRef.refreshList()
          })
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.tab {
  padding: 20px 20px 0 20px;
}
</style>
